local Cryolysis2 = Cryolysis2
local L = AceLibrary("AceLocale-2.2"):new("Cryolysis2")

------------------------------------------------------------------------------------------------------
-- Update properties of the left button
------------------------------------------------------------------------------------------------------
function Cryolysis2:UpdateBottomButton(click)

	local actionName, ID, BottomTex

	if click == 1 then
		actionName = Cryolysis2.db.profile.BottomSpellLeft
	end
	if click == 2 then
		actionName = Cryolysis2.db.profile.BottomSpellRight
	end
	if click == 3 then
		actionName = Cryolysis2.db.profile.BottomSpellMid
	end

	-- Workaround for this not being set properly by the other function
	Cryo2BottomCustomButton:SetAttribute("type*", Cryolysis2.db.profile.BottomCustomButtonType)
	
	if actionName == nil or actionName == "" then
		if click == 1 then
			Cryo2BottomCustomButtonIcon:SetTexture(nil)
		end
		Cryo2BottomCustomButton:SetAttribute(Cryolysis2.db.profile.BottomCustomButtonType..click, actionName)
	else
		if Cryolysis2.db.profile.BottomCustomButtonType == "spell" then
			ID = Cryolysis2:FindSpellID(""..actionName, BOOKTYPE_SPELL)
			if ID > 0 then
				BottomTex = GetSpellTexture(ID, BOOKTYPE_SPELL)
				if click == 1 then
					Cryo2BottomCustomButtonIcon:SetTexture(BottomTex)
				end
				Cryo2BottomCustomButton:SetAttribute(Cryolysis2.db.profile.BottomCustomButtonType..click, actionName)
			else
				Cryolysis2:Print(L["Invalid name, please check your spelling and try again!"])
			end
		end
		if Cryolysis2.db.profile.BottomCustomButtonType == "macro" then
			ID = GetMacroIndexByName(actionName)
			if ID > 0 then
				_, BottomTex = GetMacroInfo(ID)
				if click == 1 then
					Cryo2BottomCustomButtonIcon:SetTexture(BottomTex)
				end
				Cryo2BottomCustomButton:SetAttribute(Cryolysis2.db.profile.BottomCustomButtonType..click, actionName)
			else
				Cryolysis2:Print(L["Invalid name, please check your spelling and try again!"])
			end
		end
		if Cryolysis2.db.profile.BottomCustomButtonType == "item" then
			if GetItemInfo(actionName) then
				_, _, _, _, _, _, _, _, _, BottomTex = GetItemInfo(actionName)
				if click == 1 then
					Cryo2BottomCustomButtonIcon:SetTexture(BottomTex)
				end
				Cryo2BottomCustomButton:SetAttribute(Cryolysis2.db.profile.BottomCustomButtonType..click, actionName)
			else
				Cryolysis2:Print(L["Invalid name, please check your spelling and try again!"])
			end
		end
	end
end